//+-------------------------------------------------------------------------------------------+
//|                                                                                           |
//|                               BaboSon Solid Dragon-Trend.mq4                               |
//|                                                                                           |
//+-------------------------------------------------------------------------------------------+ 
#property copyright "Copyright @ 2013 vinco"
#property link      "email: bauwagen72@gmail.com"
//+-------------------------------------------------------------------------------------------+
//| Indicator Global Inputs                                                                   |                                                        
//+-------------------------------------------------------------------------------------------+ 
#property indicator_chart_window
#property indicator_buffers  6

//Dragon-
#property indicator_color1   C'40,45,100'     //high area
#property indicator_color2   C'40,45,100'     //low area 
#property indicator_color3   C'40,45,100'     //top line     
#property indicator_color4   C'40,45,100'     //bot line  
#property indicator_color5   C'100,100,100'   //cntr line 
#property indicator_width1   4
#property indicator_width2   4
#property indicator_width3   5
#property indicator_width4   5
#property indicator_width5   1
#property indicator_style1   STYLE_SOLID
#property indicator_style2   STYLE_SOLID
#property indicator_style3   STYLE_SOLID
#property indicator_style4   STYLE_SOLID 
#property indicator_style5   STYLE_SOLID 

//Trend-
#property indicator_color6   C'215,0,215'    
#property indicator_width6   1
#property indicator_style6   STYLE_SOLID

//global external inputs
extern bool   Indicator_On                    = true;
extern bool   Automatic_Zoom                  = false;
extern int    Manual_Zoom_01234               = 1;
extern bool   Dragon_On                       = true;
extern bool   Trend_On                        = false; 
extern int    Display_Min_TF                  = 1;
extern int    Display_Max_TF                  = 43200;
extern string TF_Choices_1                    = "M1 - H4 =  1, 5, 15, 30, 60, 240";
extern string TF_Choices_2                    = "D  W  M =  1440,  10080,  43200";

extern string __                              = "";
extern string Part_2                          = "Dragon-Trend Display Options:";
extern bool   M5_On_M15                       = false;
extern bool   M15_On_M30                      = false;
extern bool   M15_On_H1                       = false;
extern bool   H1_On_H4                        = false; 

//Global Buffers and Variables
//General-
bool    FLAG_deinit;

//Dragon-
int     Wide_Bar_Width,TopEdge,BotEdge,i,counted_bars,limit,BarShift;
double  DragonHigh[], DragonLow[], DragonTop[], DragonBot[], DragonCntr[];
string  Dragon_MA_String              = "EMA";
int     Dragon_MA_Type                = 1;
int     Centerline                    = 0;
int     Dragon_MA_Period              = 34;
bool    Dragon_Exp_vs_Simple          = true;

//Trend-
double  Trend[];
string  Trend_MA_String               = "EMA";
int     Trend_MA_Type                 = 1;
int     Trend_MA_Price                = 0;
int     Trend_MA_Period               = 89;
bool    Trend_Exp_vs_Simple           = true;  

/*General notes:
MAType   = 0=SMA,1=EMA,2=SMMA,3=LWMA
MAPrice  = 0=CLOSE,1=OPEN,2=HIGH,3=LOW,4=MEDIAN,5=PP,6=WEIGHT
*/

//Automatic Zoom Parameters
string note1                           = "Auto-Width_Adjustments:";
string note2                           = "Wide monitors may require";
string note3                           = "WindowsBarsPerChart be increased";
string note4                           = "for these chart zoom settings:";
int    Zoom_Out_2_Bars                 = 1200;
int    Zoom_Out_1_Bars                 = 500;
int    Zoom_Std_Bars                   = 200;
int    Zoom_In_1_Bars                  = 100;
int    Zoom_In_2_Bars                  = 60;

//+-------------------------------------------------------------------------------------------+
//| Indicator Initialization                                                                  |                                                        
//+-------------------------------------------------------------------------------------------+      
int init()
  {
  FLAG_deinit = false;

  //Automatically Adjust Width      
  if(Automatic_Zoom)   
    {   
          if (WindowBarsPerChart( ) >= Zoom_Out_2_Bars) {Wide_Bar_Width=1; TopEdge=1; BotEdge=1;} 
    else {if (WindowBarsPerChart( ) >= Zoom_Out_1_Bars) {Wide_Bar_Width=2; TopEdge=1; BotEdge=1;} 
    else {if (WindowBarsPerChart( ) >= Zoom_Std_Bars)   {Wide_Bar_Width=3; TopEdge=3; BotEdge=3;} 
    else {if (WindowBarsPerChart( ) >= Zoom_In_1_Bars)  {Wide_Bar_Width=5; TopEdge=7; BotEdge=7;} 
    else {if (WindowBarsPerChart( ) >= Zoom_In_2_Bars)  {Wide_Bar_Width=9; TopEdge=14; BotEdge=14;} 
    else {Wide_Bar_Width=17; TopEdge=26; BotEdge=26;} }}}}
    }
  else //Manually Adjust Width
    {
          if (Manual_Zoom_01234 <= 0) {Wide_Bar_Width = 2; TopEdge = 1;BotEdge = 1;}
    else {if (Manual_Zoom_01234 == 1) {Wide_Bar_Width = 3; TopEdge = 3;BotEdge = 3;}
    else {if (Manual_Zoom_01234 == 2) {Wide_Bar_Width = 5; TopEdge = 7;BotEdge = 7;}
    else {if (Manual_Zoom_01234 == 3) {Wide_Bar_Width = 9; TopEdge = 14;BotEdge = 14;}
    else {Wide_Bar_Width = 17; TopEdge = 26;BotEdge = 26;} }}}
    }        
  
  //Indicators    
  if(Dragon_On)
    {              
    SetIndexBuffer(0, DragonHigh);
    SetIndexBuffer(1, DragonLow);
    SetIndexBuffer(2, DragonTop);
    SetIndexBuffer(3, DragonBot);
    SetIndexBuffer(4, DragonCntr);                   
    SetIndexStyle(0, DRAW_HISTOGRAM, 0, Wide_Bar_Width);    
    SetIndexStyle(1, DRAW_HISTOGRAM, 0, Wide_Bar_Width);    
    SetIndexStyle(2, DRAW_LINE, 0, TopEdge); 
    SetIndexStyle(3, DRAW_LINE, 0, BotEdge);
    SetIndexStyle(4, DRAW_LINE); 
    }                                   
  if(Trend_On) 
    {    
    SetIndexBuffer(5, Trend);                     
    SetIndexStyle(5, DRAW_LINE);          
    }
      
  //Indicator ShortName    
  if(Dragon_On && Trend_On)
    {
    if(M5_On_M15 && Period() == 15) 
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M5  "+Dragon_MA_Period+" "+Dragon_MA_String
      +",  M5  "+Trend_MA_Period+" "+ Trend_MA_String+" ) ");
      }
    else if((M15_On_M30 && Period() == 30) ||
      (M15_On_H1 && Period() == 60))
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M15  "+Dragon_MA_Period+" "+Dragon_MA_String
      +",  M15  "+Trend_MA_Period+" "+ Trend_MA_String+" ) ");
      } 
    else if(H1_On_H4 && Period() == 240)
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( H1  "+Dragon_MA_Period+" "+Dragon_MA_String
      +",  H1  "+Trend_MA_Period+" "+ Trend_MA_String+" ) ");
      }     
    else
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( "+Dragon_MA_Period+" "+Dragon_MA_String
      +",  "+Trend_MA_Period+" "+ Trend_MA_String+" ) ");
      }         
    }
  else if(Dragon_On && !Trend_On)
    {
    if(M5_On_M15 && Period() == 15)
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M5  "+Dragon_MA_Period+" "+Dragon_MA_String+" ) ");
      }
    else if((M15_On_M30 && Period() == 30) ||
      (M15_On_H1 && Period() == 60))
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M15  "+Dragon_MA_Period+" "+Dragon_MA_String+" ) ");
      } 
    else if(H1_On_H4 && Period() == 240)
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( H1  "+Dragon_MA_Period+" "+Dragon_MA_String+" ) ");
      }
    else
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( "+Dragon_MA_Period+" "+Dragon_MA_String+" ) ");
      }           
    }    
  else if(Trend_On && !Dragon_On)
    {
    if(M5_On_M15 && Period() == 15)
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M5  "+Trend_MA_Period+" "+Trend_MA_String+" ) ");
      }
    else if((M15_On_M30 && Period() == 30) ||
      (M15_On_H1 && Period() == 60))
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( M15  "+Trend_MA_Period+" "+Trend_MA_String+" ) ");
      }
    else if(H1_On_H4 && Period() == 240)
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( H1  "+Trend_MA_Period+" "+Trend_MA_String+" ) ");
      }
    else
      {
      IndicatorShortName("BaboSon Solid Dragon-Trend ( "+Trend_MA_Period+" "+ Trend_MA_String+" ) ");
      }           
    }  
                                         
                                         
  return(0);
  }

//+-------------------------------------------------------------------------------------------+
//| Indicator De-initialization                                                               |                                                        
//+-------------------------------------------------------------------------------------------+      
int deinit()
  {      
  return(0);
  }

//+-------------------------------------------------------------------------------------------+
//| Indicator Start                                                                           |                                                        
//+-------------------------------------------------------------------------------------------+     
int start()
  {
  //If indicator is "Off" or chart TF is out of range deinitialize only once, not every tick.  
  if((!Indicator_On) || ((Period() < Display_Min_TF) || (Period() > Display_Max_TF)))    
    {
    if (!FLAG_deinit) {deinit(); FLAG_deinit = true;}
    return(0);
    }

  //Otherwise indicator is "On" & chart TF is in display range, so proceed.   
  if(Automatic_Zoom) {init();}
  else {deinit(); FLAG_deinit = false;}
                       
  //Calculate MAs   
  //check for possible errors
  counted_bars = IndicatorCounted();
  if(counted_bars < 0)  return(-1); 
     
  //last counted bar will be recounted
  if(counted_bars > 0) counted_bars--;    
  limit = Bars - counted_bars;

  for(i = limit - 1; i >= 0; i--)
    {
    if(Dragon_On)
      {
      if(M5_On_M15 && Period() == 15)  
        { 
        BarShift = iBarShift(NULL,5,Time[i],true); 
        DragonHigh[i]   = iMA(NULL,5,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift);
        DragonLow[i]    = iMA(NULL,5,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);       
        DragonTop[i]    = iMA(NULL,5,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift); 
        DragonBot[i]    = iMA(NULL,5,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);
        DragonCntr[i] = iMA(NULL,5,Dragon_MA_Period,0,Dragon_MA_Type,Centerline,BarShift);   
        }       
      else if((M15_On_M30 && Period() == 30)  ||  (M15_On_H1 && Period() == 60))
        { 
        BarShift = iBarShift(NULL,15,Time[i],true); 
        DragonHigh[i]   = iMA(NULL,15,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift);
        DragonLow[i]    = iMA(NULL,15,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);       
        DragonTop[i]    = iMA(NULL,15,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift); 
        DragonBot[i]    = iMA(NULL,15,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift); 
        DragonCntr[i] = iMA(NULL,15,Dragon_MA_Period,0,Dragon_MA_Type,Centerline,BarShift); 
        }
      else if (H1_On_H4 && Period() == 240) 
        { 
        BarShift = iBarShift(NULL,60,Time[i],true); 
        DragonHigh[i]   = iMA(NULL,60,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift);
        DragonLow[i]    = iMA(NULL,60,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);       
        DragonTop[i]    = iMA(NULL,60,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift); 
        DragonBot[i]    = iMA(NULL,60,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift); 
        DragonCntr[i] = iMA(NULL,60,Dragon_MA_Period,0,Dragon_MA_Type,Centerline,BarShift); 
        }                 
      else    
        {              
        BarShift = iBarShift(NULL,NULL,Time[i],true); 
        DragonHigh[i]   = iMA(NULL,NULL,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift);   
        DragonLow[i]    = iMA(NULL,NULL,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);                    
        DragonTop[i]    = iMA(NULL,NULL,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_HIGH,BarShift);                           
        DragonBot[i]    = iMA(NULL,NULL,Dragon_MA_Period,0,Dragon_MA_Type,PRICE_LOW,BarShift);
        DragonCntr[i] = iMA(NULL,NULL,Dragon_MA_Period,0,Dragon_MA_Type,Centerline,BarShift);
        }
      //Brokers with short Sunday sessions lack necessary data to make Dragon continuous, so when
      //there is a data "dropout" (current value<half previous value), fill with average data: 
      if(DragonHigh[i+1]< DragonHigh[i+2]/2){DragonHigh[i+1]= (DragonHigh[i+2]+ DragonHigh[i])/2;}
      if(DragonLow[i+1]< DragonLow[i+2]/2){DragonLow[i+1]= (DragonLow[i+2]+ DragonLow[i])/2;}
      if(DragonTop[i+1]< DragonTop[i+2]/2){DragonTop[i+1]= (DragonTop[i+2]+ DragonTop[i])/2;}
      if(DragonBot[i+1]< DragonBot[i+2]/2){DragonBot[i+1]= (DragonBot[i+2]+ DragonBot[i])/2;}      
      if(DragonCntr[i+1]< DragonCntr[i+2]/2){DragonCntr[i+1]= (DragonCntr[i+2]+ DragonCntr[i])/2;}                 
      }
         
    if(Trend_On)   
      {
      if(M5_On_M15 && Period() == 15)   
        {
        BarShift = iBarShift(NULL,5,Time[i],true);                 
        Trend[i]   = iMA(NULL,5,Trend_MA_Period,0,Trend_MA_Type,Trend_MA_Price,BarShift); 
        } 
      else if((M15_On_M30 && Period() == 30)  ||  (M15_On_H1 && Period() == 60))
        {
        BarShift = iBarShift(NULL,15,Time[i],true);                 
        Trend[i]   = iMA(NULL,15,Trend_MA_Period,0,Trend_MA_Type,Trend_MA_Price,BarShift);   
        }
      else if (H1_On_H4 && Period() == 240) 
        {
        BarShift = iBarShift(NULL,60,Time[i],true);                 
        Trend[i]   = iMA(NULL,60,Trend_MA_Period,0,Trend_MA_Type,Trend_MA_Price,BarShift);
        }     
      else
        {   
        BarShift = iBarShift(NULL,NULL,Time[i],true);                 
        Trend[i]   = iMA(NULL,NULL,Trend_MA_Period,0,Trend_MA_Type,Trend_MA_Price,BarShift);             
        }
      //Brokers with short Sunday sessions lack necessary data to make Trend continuous, so when
      //there is a data "dropout" (current value<half previous value), fill with average data:
      if(Trend[i+1]< Trend[i+2]/2){Trend[i+1]= (Trend[i+2]+ Trend[i])/2;}         
      }   
    }                
                                                                                                                  
  return(0);
  }

//+-------------------------------------------------------------------------------------------+
//| Indicator End                                                                             |                                                        
//+-------------------------------------------------------------------------------------------+       

